'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _inlineStylePrefixer = require('inline-style-prefixer');

var _inlineStylePrefixer2 = _interopRequireDefault(_inlineStylePrefixer);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

var prefixer = new _inlineStylePrefixer2.default();
var range = function range(n) {
  return [].concat(_toConsumableArray(Array(n))).map(function (_, i) {
    return i;
  });
};

var sx = {
  display: 'flex',
  justifyContent: 'center'
};

if (typeof document !== 'undefined') {
  sx = prefixer.prefix(sx);
}

var Dots = function Dots(_ref) {
  var activeClassName = _ref.activeClassName;
  var slideCount = _ref.slideCount;
  var currentSlide = _ref.currentSlide;
  var _onClick = _ref.onClick;
  return _react2.default.createElement(
    'div',
    { style: sx },
    range(slideCount).map(function (x, i) {
      return _react2.default.createElement('div', {
        className: i === currentSlide ? activeClassName : '',
        onClick: function onClick() {
          return _onClick(i - currentSlide);
        },
        style: {
          width: 8,
          height: 8,
          borderRadius: 8,
          backgroundColor: 'black',
          opacity: i === currentSlide ? 1 : 0.2,
          margin: 3
        },
        key: i
      });
    })
  );
};

Dots.propTypes = {
  className: _react.PropTypes.string,
  currentSlide: _react.PropTypes.number,
  onClick: _react.PropTypes.func,
  slideCount: _react.PropTypes.number
};

exports.default = Dots;